{% if p.maxPages is defined and p.maxPages > 1 and p.currentPage <= p.maxPages %}

    <nav aria-label="User Page navigation">
        <ul class="pagination justify-content-center">

            {% set queryParams = app.request.query.all %}

            {% if p.currentPage-1 < 1 %}
                {% set prevQueryParams = queryParams %}
            {% else %}
                {% set prevQueryParams = queryParams|merge({p: p.currentPage-1 < 1 ? 1 : p.currentPage-1}) %}
            {% endif %}

            <li class="page-item {{ p.currentPage == 1 ? 'disabled' }}">
                <a class="page-link" href="{{ url(app.request.attributes.get('_route'), prevQueryParams) }}" aria-label="Previous">
                    <span aria-hidden="true">&laquo;</span>
                    <span class="sr-only">Previous</span>
                </a>
            </li>


            {% set firstQueryParams = queryParams|merge({p: 1}) %}
            <li class="page-item {{ p.currentPage == 1 ? 'disabled' }}">
                <a class="page-link" href="{{ url(app.request.attributes.get('_route'), firstQueryParams) }}">First</a>
            </li>



            {#{% set i = max(2, p.currentPage - p.limitPages) %}#}

            {% for i in 1..p.maxPages %}
                {% set currentQueryParams = queryParams|merge({p: i}) %}

                <li class="page-item {{ p.currentPage == i ? 'active' }}">
                    <a class="page-link" href="{{ url(app.request.attributes.get('_route'), currentQueryParams) }}">{{ i }}</a>
                </li>
            {% endfor %}




            {% set lastQueryParams = queryParams|merge({p: p.maxPages}) %}
            <li class="page-item {{ p.currentPage == p.maxPages ? 'disabled' }}">
                <a class="page-link" href="{{ url(app.request.attributes.get('_route'), lastQueryParams) }}">Last</a>
            </li>


            {% set nextQueryParams = queryParams|merge({p: p.currentPage+1 <= p.maxPages ? p.currentPage+1 : p.currentPage}) %}
            <li class="page-item {{ p.currentPage == p.maxPages ? 'disabled' }}" >
                <a class="page-link" href="{{ url(app.request.attributes.get('_route'), nextQueryParams) }}" aria-label="Next">
                    <span aria-hidden="true">&raquo;</span>
                    <span class="sr-only">Next</span>
                </a>
            </li>

        </ul>
    </nav>

{#
    $links = "";
    if ($total_pages >= 1 && $current_page <= $total_pages) {
        $links .= "<a href=\"{$url}?page=1\">1</a>";
        $i = max(2, $current_page - 5);
        if ($i > 2)
            $links .= " ... ";
        for (; $i < min($current_page + 6, $total_pages); $i++) {
            $links .= "<a href=\"{$url}?page={$i}\">{$i}</a>";
        }
        if ($i != $total_pages)
            $links .= " ... ";
        $links .= "<a href=\"{$url}?page={$total_pages}\">{$total_pages}</a>";
    }

    OUTPUT:

    page = 1
    1 2 3 4 5 6 ... 20

    page = 10
    1 ... 5 6 7 8 9 10 11 12 13 14 15 ... 20

    page = 19
    1 ... 14 15 16 17 18 19 20
#}

{% endif %}